package com.sleepycat.je.log;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import com.sleepycat.je.mock.DatabaseException;
import com.sleepycat.je.mock.DbChecksumException;
import com.sleepycat.je.mock.EnvironmentImpl;

public class LogManagerTest {

	private EnvironmentImpl env;
	private LogManager l;

//	@Before
	public void setUp() throws Exception {
		env = new EnvironmentImpl();
		l = new LogManager(env, true);
	}

//	@Test
	public void testLogManagerConstructor() throws DatabaseException {
		Assert.assertTrue(l.doChecksumOnRead);
		Assert.assertTrue(l.getChecksumOnRead());
	}

//	@Test
	public void testGetLogEntryFromLogSourceCFlow() throws DatabaseException {
		LogEntry e = l.getLogEntryFromLogSource(0, new MockLogSource(true));
		Assert.assertEquals(3, e.version);
		Assert.assertEquals(4, e.size);
		Assert.assertEquals("abcd", e.content);
	}

//	@Test
	public void testFailedChecksum() throws DatabaseException {
		try {
			LogEntry e = l.getLogEntryFromLogSource(0, new MockLogSource(false));
			Assert.fail();
		} catch (DatabaseException e) {
		}
		
	}

}
