package com.sleepycat.je.log;

import java.nio.ByteBuffer;

public class MockLogSource implements LogSource {

	private ByteBuffer destBuf;
	private boolean correctChecksum;

	public MockLogSource(boolean b) {
		this.correctChecksum=b;
	}

	public void init() {
		if (destBuf != null)
			return;
		destBuf = ByteBuffer.allocate(50);
		if (correctChecksum)
			destBuf.put(new byte[] { (byte)216L, 0, 95, 2 });// checksum
		else
			destBuf.put(new byte[] { 12, 31, 4, 2 });// checksum
		destBuf.put((byte) 3);// type
		destBuf.put((byte) 3);// version
		destBuf.put(new byte[] { 1, 3, 4, 2 });// prev
		destBuf.putInt(4);// size
		destBuf.putChar('a');
		destBuf.putChar('b');
		destBuf.putChar('c');
		destBuf.putChar('d');
	}

	public ByteBuffer getBytes(int fileOffset) {
		init();
		destBuf.position(fileOffset);
		return destBuf;
	}

	public ByteBuffer getBytes(int l, int itemSize) {
		init();
		destBuf.position(l);
		return destBuf;
	}

	public void release() {
		// TODO Auto-generated method stub

	}

}
