import java.util.Random;

public class Consumer exhibits ConsumerCreation {
	
	pointcut ConsumerCreation : execution(new(..)) && this(consumer);

	private Random random = new Random();
	private boolean working = false;
	
	private String name;

	public Consumer(String n) {
		name = n;				
	}
	
	public String getName() {return name;}
	
	public void consume(Item it) {
		
		working = true;		
		System.out.println("["+name+"] consuming "+it.value);
		Runnable r = new Runnable() {
			public void run() {
				int sleep = random.nextInt(2000) + 750;
				System.out.println("["+name+"] sleeping for "+sleep);
				try {
					Thread.sleep(sleep);
				} catch(InterruptedException e) {
					System.err.println(e);
				}
				working = false;
				System.out.println("["+name+"] ready for new Items");
			}
		};
		Thread th = new Thread(r);
		th.start();		
	}
	
	public boolean isWorking() {return working;}
	
}