import java.util.Random;

public class Producer implements Runnable exhibits ItemProducing {
	
	pointcut ItemProducing : execution(Item produceItem());
	
	private int numberOfItems = 0;
	private Random random = new Random();
	
	public Producer(int numberOfItems) {
		this.numberOfItems = numberOfItems;		
	}
	
	public void run() {

		System.out.println("[producer]\tstart producing "+numberOfItems+" items");
		for(int i = 0; i < numberOfItems; i++) {
			Item it = produceItem();
			System.out.println("[producer] item "+i+" : "+it.value);
			try {
				Thread.sleep(1000);
			} catch(InterruptedException e) {
				System.err.println(e);
			}
						
		}
		System.out.println("[producer] stop producing");
	}
	
	private Item produceItem() {
		int i = random.nextInt(10);
		Item it = new Item();
		it.value = i;
		return it;
	}
	
}